<script type="text/javascript">
var interfaceBOUser = Class.create( {

    initialize: function( nbUsers, jsonUsers, jsonUserRoles )
    {
        // Values
        this.jsonUsers = jsonUsers || null;
        this.jsonUserRoles = jsonUserRoles || null;
        this.user = false;
        this.nbUsers = nbUsers || false;

        // Containers
        this.generalContainerUsers = $( "#generalContainerUsers" );
        this.containerUsers = $( "#containerUsers" );
        this.containerRoles = $( "#containerRoles" );
        this.containerAddOrModifyTitle = $( "#addOrModifyTitle" );
        this.containerErrors = $( "#errors" );
        this.containerUsersNumber = $( "#nbResults" );

        this.containerSorts = $( "#containerSorts" );
        this.containerSortsRoles = $( "#containerSorts_roles" );
        this.containerSortsDisplay = $( "#containerSorts_display" );
        this.containerPage = $( "#page" );
        this.containerMaxPage = $( "#maxPages" );

        /** *********** LOADING *********** **/
        // Create loading object for users
        var param = new Object();
        param.id = "loadingForUser";
        param.parent = this.generalContainerUsers;
        this.loadingUser = new Loading( param );
        this.loadingUser.display();

        this.containerErrors.hide();
        this.updateAddUserButtonAndTitle();
        this.displaySorts();
        this.managePartAddOrModify();
        this.managePagination();
        this.displayUsers();
    },

    // REQUESTS ********************************************************
    requestAddUser: function()
    {
        if( !this.verifyFields() )
        {
            var parametersUrl = "name=" + $( "#lastName" ).val() + "&firstName=" + $( "#firstName" ).val() + "&email=" + $( "#email" ).val() +
                    "&pwd=" + $( "#password" ).val() + "&role=" + this.selectRoles.getValue() + "&laboratory=" + $( "#laboratory" ).val() + "&country=" + $( "#country" ).val() +
                    "&hasAccess=" + $( "#boAccess" ).attr( 'checked' );
            var request = $.ajax( {
                url: "backoffice?methodName=addUser&" + parametersUrl,
                success:jQuery.proxy( this.handleUser, this ),
                error: jQuery.proxy( this.showErrors, [this] )
            } );
        }
    },

    requestRemoveUser: function()
    {
        if( this.user )
            $.ajax( {
                url: "backoffice?methodName=removeUser&id=" + this.user.id,
                success:jQuery.proxy( this.handleUser, this )
            } );
    },

    requestModifyUser: function()
    {
        if( this.user && !this.verifyFields() )
        {
            var parametersUrl = "id=" + this.user.id + "&name=" + $( "#lastName" ).val() + "&firstName=" + $( "#firstName" ).val() + "&email=" + $( "#email" ).val() +
                    "&pwd=" + $( "#password" ).val() + "&role=" + this.selectRoles.getValue() + "&laboratory=" + $( "#laboratory" ).val() + "&country=" + $( "#country" ).val() +
                    "&hasAccess=" + $( "#boAccess" ).attr( 'checked' ) + "&keepSamePassword=" + $( "#keepSamePassword" ).attr( 'checked' );
            $.ajax( {
                url: "backoffice?methodName=modifyUser&" + parametersUrl,
                success:jQuery.proxy( this.handleUser, this ),
                error: jQuery.proxy( this.showErrors, [this] )
            } );
        }
    },

    requestSortUser: function()
    {
        var parametersUrl = "sort=" + this.selectSorts.getValue() + "&sortRole=" + this.selectSortsRoles.getValue() + "&searchText=" + $( "#search_text" ).val() +
                "&sortAccessBoTrue=" + $( "#sort_accessBO_true" ).attr( 'checked' ) + "&sortAccessBoFalse=" + $( "#sort_accessBO_false" ).attr( 'checked' ) +
                "&maxResults=" + this.selectSortsDisplay.getValue() + "&page=" + this.containerPage.html();
        var request = $.ajax( {
            url: "backoffice?methodName=sortUser&" + parametersUrl,
            success:jQuery.proxy( this.handleSortUser, this ),
            error: jQuery.proxy( this.showErrors, [this] )
        } );
    },

    // HANDLES ********************************************************
    handleUser: function()
    {
        this.requestSortUser();
    },

    handleSortUser: function( result )
    {
        try
        {
            this.jsonUsers = jQuery.parseJSON( result ).jSonUsers;
            this.nbUsers = jQuery.parseJSON( result ).usersNumber;
            this.displayUsers();
            this.clearAddOrModifyUserFields();
            this.updateAddUserButtonAndTitle();
        }
        catch( err )
        {
            document.location.reload();
        }
    },

    // DISPLAYS ********************************************************
    displayTRForUser: function( user )
    {
        var tr = $( document.createElement( "tr" ) );
        var tdId = $( document.createElement( "td" ) );
        tdId.html( user.id );
        tr.append( tdId );
        var tdLastName = $( document.createElement( "td" ) );
        tdLastName.html( user.lastName );
        tr.append( tdLastName );
        var tdFirstName = $( document.createElement( "td" ) );
        tdFirstName.html( user.firstName );
        tr.append( tdFirstName );
        var tdEmail = $( document.createElement( "td" ) );
        tdEmail.html( user.email );
        tr.append( tdEmail );
        var tdRole = $( document.createElement( "td" ) );
        tdRole.html( user.role );
        tr.append( tdRole );
        var tdLaboratory = $( document.createElement( "td" ) );
        tdLaboratory.html( user.laboratory );
        tr.append( tdLaboratory );
        var tdCountry = $( document.createElement( "td" ) );
        tdCountry.html( user.country );
        tr.append( tdCountry );

        var tdDate = $( document.createElement( "td" ) );
        tdDate.html( formatDate( new Date( user.creationDate.time ) ) );
        tr.append( tdDate );
        return tr;
    },

    displayUsers: function()
    {
        this.containerUsers.empty();

        if( this.jsonUsers && 0 < this.jsonUsers.length )
        {
            jQuery.each( this.jsonUsers, jQuery.proxy( function( i, user )
            {
                var tr = this.displayTRForUser( user );

                var tdBO = $( document.createElement( "td" ) );
                var imgBO = $( document.createElement( "img" ) );
                if( user.accessToBO )
                    imgBO.attr( {width:"10", height:"10", src:"resources/images/utils/ok.png"} );
                else
                    imgBO.attr( {width:"10", height:"10", src:"resources/images/utils/not.png"} );
                tdBO.append( "&nbsp;" ).append( imgBO );
                tr.append( tdBO );

                // Buttons
                var tdModify = $( document.createElement( "td" ) );
                var buttonModify = new Button( {value:interfaceTexts["bo.modify"], parent:tdModify, id:"button_modify", className: "small positive action_button", contextToSave: user, onClick:jQuery.proxy( this.onClickModify, this )} );
                tr.append( tdModify );

                var tdRemove = $( document.createElement( "td" ) );
                var buttonRemove = new Button( {value:interfaceTexts["bo.remove"], parent:tdRemove, id:"button_remove", className: "small negative action_button", contextToSave: user, onClick:jQuery.proxy( this.onClickRemove, this )} );
                tr.append( tdRemove );

                this.containerUsers.append( tr );

            }, this ) );
        }
        else
        {
            var tr = $( document.createElement( "tr" ) );
            var td = $( document.createElement( "td" ) );
            td.attr( {colspan:"11"} );
            td.html( "<center><BR/>" + interfaceTexts["bo.noUser"] + "<BR/><BR/></center>" );
            tr.append( td );
            this.containerUsers.append( tr );
        }

        // Update number of users and max pages
        this.containerUsersNumber.html( this.nbUsers );
        this.containerMaxPage.html( Math.ceil( this.nbUsers / this.selectSortsDisplay.getValue() ) );
        this.loadingUser.hide();
    },

    displayRoles: function()
    {
        var paramSelect = new Object();
        paramSelect.id = "select_roles";
        paramSelect.parent = this.containerRoles;
        this.selectRoles = new Select( paramSelect );
        jQuery.each( this.jsonUserRoles, jQuery.proxy( function ( i, jsonUserRole )
        {
            this.selectRoles.add( jsonUserRole.value, interfaceTexts[jsonUserRole.text] );
        }, this ) );
        this.selectRoles.selectFirst( false );
    },

    displaySorts: function()
    {
        // Sort by name, email, ...
        var paramSelect = new Object();
        paramSelect.id = "select_sorts";
        paramSelect.parent = this.containerSorts;
        this.selectSorts = new Select( paramSelect );
        this.selectSorts.add( "lastName", interfaceTexts["bo.user.lastName"] );
        this.selectSorts.add( "id", interfaceTexts["bo.id"] );
        this.selectSorts.add( "email", interfaceTexts["bo.user.email"] );
        this.selectSorts.add( "creationDate", interfaceTexts["bo.user.creationDate"] );
        this.selectSorts.selectFirst( false );

        // Sort by role
        var paramSelect = new Object();
        paramSelect.id = "select_sorts_roles";
        paramSelect.parent = this.containerSortsRoles;
        this.selectSortsRoles = new Select( paramSelect );
        this.selectSortsRoles.add( "ALL", interfaceTexts["bo.all"] );
        jQuery.each( this.jsonUserRoles, jQuery.proxy( function ( i, jsonUserRole )
        {
            this.selectSortsRoles.add( jsonUserRole.value, interfaceTexts[jsonUserRole.text] );
        }, this ) );
        this.selectSortsRoles.selectFirst( false );

        // Number of displays
        var paramSelect = new Object();
        paramSelect.id = "select_sorts_display";
        paramSelect.parent = this.containerSortsDisplay;
        this.selectSortsDisplay = new Select( paramSelect );
        this.selectSortsDisplay.add( "5", 5 );
        this.selectSortsDisplay.add( "10", 10 );
        this.selectSortsDisplay.add( "15", 15 );
        this.selectSortsDisplay.add( "20", 20 );
        this.selectSortsDisplay.selectFirst( false );

        // Button sort
        $( "#sortButton" ).bind( 'click', this, jQuery.proxy( this.onClickSort, this ) );
    },

    // EVENTS ********************************************************
    onClickModify: function( user )
    {
        this.user = user;
        $( "#lastName" ).val( user.lastName );
        $( "#firstName" ).val( user.firstName );
        $( "#email" ).val( user.email );
        $( "#password" ).attr( 'disabled', true );
        $( "#keepSamePassword" ).attr( 'disabled', false );
        $( "#keepSamePassword" ).attr( 'checked', true );
        this.selectRoles.select( user.role, false );
        $( "#boAccess" ).attr( 'checked', user.accessToBO );
        $( "#laboratory" ).val( user.laboratory );
        $( "#country" ).val( user.country );

        this.updateModifyUserButtonAndTitle( user.id );
    },

    onClickRemove: function( user )
    {
        this.user = user;
        if( window.confirm( interfaceTexts["bo.user.remove.confirm"] + " " + user.firstName + " " + user.lastName + " ?" ) )
            jQuery.proxy( this.requestRemoveUser(), this );
    },

    onCheckKeepSamePassword: function()
    {
        var actualState = $( "#keepSamePassword" ).attr( 'checked' );
        $( "#password" ).attr( 'disabled', actualState );
        if( actualState )
            $( "#password" ).val( '' );
    },

    onClickInit: function()
    {
        this.updateAddUserButtonAndTitle();
        this.clearAddOrModifyUserFields();
    },

    onClickSort: function()
    {
        this.containerPage.html( 1 );
        this.requestSortUser();
    },

    onClickPrevious: function()
    {
        decrementPage( this.containerPage, this.containerMaxPage );
        this.requestSortUser();
    },

    onClickNext: function()
    {
        incrementPage( this.containerPage, this.containerMaxPage );
        this.requestSortUser();
    },

    // OTHERS ********************************************************
    updateAddUserButtonAndTitle: function()
    {
        this.containerAddOrModifyTitle.empty();
        this.containerAddOrModifyTitle.html( interfaceTexts["bo.user.add"] + " :<BR/><BR/>" );
        $( "#add_or_modify_user" ).unbind( 'click' );
        $( "#add_or_modify_user" ).bind( 'click', this, jQuery.proxy( this.requestAddUser, this ) );
        $( "#add_or_modify_user" ).html( interfaceTexts["bo.add"] );
        $( "#password" ).attr( 'disabled', false );
        $( "#keepSamePassword" ).attr( 'disabled', true );
    },

    updateModifyUserButtonAndTitle: function( userId )
    {
        this.containerAddOrModifyTitle.empty();
        this.containerAddOrModifyTitle.html( interfaceTexts["bo.user.modify"] + " (id : " + userId + ")<BR/><BR/>" );
        $( "#add_or_modify_user" ).unbind( 'click' );
        $( "#add_or_modify_user" ).bind( 'click', this, jQuery.proxy( this.requestModifyUser, this ) );
        $( "#add_or_modify_user" ).html( interfaceTexts["bo.modify"] );
        $( "#password" ).attr( 'disabled', true );
        $( "#keepSamePassword" ).attr( 'disabled', false );
    },

    clearAddOrModifyUserFields: function()
    {
        $( ':input', '#addOrModifyForm' )
                .not( ':button, :submit, :reset, :hidden' )
                .val( '' )
                .removeAttr( 'checked' )
                .removeAttr( 'selected' );

        this.selectRoles.selectFirst( false );
    },

    verifyFields: function()
    {
        this.containerErrors.hide();

        var errors = false;
        if( '' == $( "#lastName" ).val() )
            errors = interfaceTexts["bo.field.lastName"];
        if( '' == $( "#email" ).val() )
            errors = !errors ? interfaceTexts["bo.field.email"] : errors + "<BR/>" + interfaceTexts["bo.field.email"];
        if( '' == $( "#password" ).val() && !$( "#keepSamePassword" ).attr( 'checked' ) )
            errors = !errors ? interfaceTexts["bo.field.password"] : errors + "<BR/>" + interfaceTexts["bo.field.password"];

        if( errors )
        {
            this.containerErrors.show();
            this.containerErrors.html( errors );
        }
        return errors;
    },

    showErrors: function( result )
    {
        var context = this[0];
        var text = this[1];
        context.containerErrors.show();
        if( text )
            context.containerErrors.html( interfaceTexts[result.responseText] + " " + text );
        else
            context.containerErrors.html( interfaceTexts[result.responseText] );
    },

    managePartAddOrModify: function()
    {
        this.displayRoles();

        $( "#keepSamePassword" ).attr( 'disabled', true );
        $( "#keepSamePassword" ).bind( 'click', this.onCheckKeepSamePassword );

        $( "#init" ).bind( 'click', this, jQuery.proxy( this.onClickInit, this ) );
    },

    managePagination: function()
    {
        $( "#previous" ).bind( 'click', this, jQuery.proxy( this.onClickPrevious, this ) );
        $( "#next" ).bind( 'click', this, jQuery.proxy( this.onClickNext, this ) );
    }

} );


</script>